"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var util_1 = require("util");
var ReadStream_1 = __importDefault(require("./ReadStream"));
var WriteStream_1 = __importDefault(require("./WriteStream"));
var SEEK_REF;
(function (SEEK_REF) {
    SEEK_REF[SEEK_REF["SEEK_SET"] = 0] = "SEEK_SET";
    SEEK_REF[SEEK_REF["SEEK_CUR"] = 1] = "SEEK_CUR";
    SEEK_REF[SEEK_REF["SEEK_END"] = 2] = "SEEK_END";
})(SEEK_REF || (SEEK_REF = {}));
/**
 * Represents an opened large object.
 * @constructor
 * @exports postgres-large-object/lib/LargeObject
 */
var LargeObject = /** @class */ (function () {
    function LargeObject(sql, oid, fd) {
        var _this = this;
        /** Closes this large object.
         *  You should no longer call any methods on this object.
         * @returns {Promise}
         */
        this.closeAsync = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["SELECT lo_close(", ") as ok"], ["SELECT lo_close(", ") as ok"])), this._fd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~closeCallback
         * @param {?Error} error If set, an error occurred.
         */
        /** Closes this large object.
         *  You should no longer call any methods on this object.
         * @param {module:postgres-large-object/lib/LargeObject~closeCallback} [callback]
         */
        this.close = util_1.callbackify(this.closeAsync);
        /** Reads some data from the large object.
         * @param {Number} length How many bytes to read
         * @returns {Promise.<Buffer>} The binary data that was read.
         *          If the length of this buffer is less than the supplied
         *          length param, there is no more data to be read.
         */
        this.readAsync = function (length) { return __awaiter(_this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_2 || (templateObject_2 = __makeTemplateObject(["SELECT loread(", ", ", ") as data"], ["SELECT loread(", ", ", ") as data"])), this._fd, length)];
                    case 1:
                        data = (_a.sent())[0].data;
                        return [2 /*return*/, data];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~readCallback
         * @param {?Error} error If set, an error occurred.
         * @param {Buffer} data The binary data that was read.
         *        If the length of this buffer is less than the supplied
         *        length param, there is no more data to be read.
         */
        /** Reads some data from the large object.
         * @param {Number} length How many bytes to read
         * @param {module:postgres-large-object/lib/LargeObject~readCallback} callback
         */
        this.read = util_1.callbackify(this.readAsync);
        /** Writes some data to the large object.
         * @param {Buffer} buffer data to write
         * @returns {Promise}
         */
        this.writeAsync = function (buffer) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_3 || (templateObject_3 = __makeTemplateObject(["SELECT lowrite(", ", ", ")"], ["SELECT lowrite(", ", ", ")"])), this._fd, buffer)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~writeCallback
         * @param {?Error} error If set, an error occurred.
         */
        /** Writes some data to the large object.
         * @param {Buffer} buffer data to write
         * @param {module:postgres-large-object/lib/LargeObject~writeCallback} [callback]
         */
        this.write = util_1.callbackify(this.writeAsync);
        /** Sets the position within the large object.
         * Beware floating point rounding with values greater than 2^53 (8192 TiB)
         * @param {Number} position
         * @param {Number} ref One of SEEK_SET, SEEK_CUR, SEEK_END
         * @returns {Promise.<number>} The new position
         */
        this.seekAsync = function (position, ref) { return __awaiter(_this, void 0, void 0, function () {
            var location;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_4 || (templateObject_4 = __makeTemplateObject(["SELECT lo_lseek64(", ", ", ", ", ")"], ["SELECT lo_lseek64(", ", ", ", ", ")"])), this._fd, position, ref)];
                    case 1:
                        location = (_a.sent())[0].location;
                        return [2 /*return*/, location];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~seekCallback
         * @param {?Error} error If set, an error occurred.
         * @param {Number} position The new position
         */
        /** Sets the position within the large object.
         * Beware floating point rounding with values greater than 2^53 (8192 TiB)
         * @param {Number} position
         * @param {Number} ref One of SEEK_SET, SEEK_CUR, SEEK_END
         * @param {module:postgres-large-object/lib/LargeObject~seekCallback} [callback]
         */
        this.seek = util_1.callbackify(this.seekAsync);
        /** Retrieves the current position within the large object.
         * Beware floating point rounding with values greater than 2^53 (8192 TiB)
         * @returns {Promise.<number>}
         */
        this.tellAsync = function () { return __awaiter(_this, void 0, void 0, function () {
            var location;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_5 || (templateObject_5 = __makeTemplateObject(["SELECT lo_tell64(", ") as location"], ["SELECT lo_tell64(", ") as location"])), this._fd)];
                    case 1:
                        location = (_a.sent())[0].location;
                        return [2 /*return*/, +location];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~tellCallback
         * @param {?Error} error If set, an error occurred.
         * @param {Number} position The position
         */
        /** Retrieves the current position within the large object.
         * Beware floating point rounding with values greater than 2^53 (8192 TiB)
         * @param {module:postgres-large-object/lib/LargeObject~tellCallback} callback
         */
        this.tell = util_1.callbackify(this.tellAsync);
        /** Find the total size of the large object.
         * @returns {Promise.<number>}
         */
        this.sizeAsync = function () { return __awaiter(_this, void 0, void 0, function () {
            var size;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n      SELECT lo_lseek64(", ", location, 0), seek.size FROM\n        (SELECT lo_lseek64(", ", 0, 2) AS SIZE, tell.location FROM \n          (SELECT lo_tell64(", ") AS location) tell) seek;\n    "], ["\n      SELECT lo_lseek64(", ", location, 0), seek.size FROM\n        (SELECT lo_lseek64(", ", 0, 2) AS SIZE, tell.location FROM \n          (SELECT lo_tell64(", ") AS location) tell) seek;\n    "])), this._fd, this._fd, this._fd)];
                    case 1:
                        size = (_a.sent())[0].size;
                        return [2 /*return*/, +size];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~sizeCallback
         * @param {?Error} error If set, an error occurred.
         * @param {Number} size Object size in bytes
         */
        /** Find the total size of the large object.
         * @param {module:postgres-large-object/lib/LargeObject~sizeCallback} callback
         */
        this.size = util_1.callbackify(this.sizeAsync);
        /** Truncates the large object to the given length in bytes.
         * If the number of bytes is larger than the current large
         * object length, the large object will be filled with zero
         * bytes.  This method does not modify the current file offset.
         * @param {Number} length
         * @returns {Promise}
         */
        this.truncateAsync = function (length) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._sql(templateObject_7 || (templateObject_7 = __makeTemplateObject(["SELECT lo_truncate(", ", ", ")"], ["SELECT lo_truncate(", ", ", ")"])), this._fd, length)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        /** @callback module:postgres-large-object/lib/LargeObject~truncateCallback
         * @param {?Error} error If set, an error occurred.
         */
        /** Truncates the large object to the given length in bytes.
         * If the number of bytes is larger than the current large
         * object length, the large object will be filled with zero
         * bytes.  This method does not modify the current file offset.
         * @param {Number} length
         * @param {module:postgres-large-object/lib/LargeObject~truncateCallback} [callback]
         */
        this.truncate = util_1.callbackify(this.truncateAsync);
        /** Return a stream to read this large object.
         * Call this within a transaction block.
         * @param {Number} [bufferSize=16384] A larger buffer size will
         * require more memory on both the server and client, however it will make
         * transfers faster because there is less overhead (less read calls to the server).
         * his overhead is most noticeable on high latency connections because each
         * ransfered chunk will incur at least RTT of additional transfer time.
         * @returns {module:postgres-large-object/lib/ReadStream}
         */
        this.getReadableStream = function (bufferSize) {
            if (bufferSize === void 0) { bufferSize = 16384; }
            return new ReadStream_1["default"](_this, bufferSize);
        };
        /** Return a stream to write to this large object.
         * Call this within a transaction block.
         * @param {Number} [bufferSize=16384] A larger buffer size will
         * require more memory on both the server and client, however it will make
         * transfers faster because there is less overhead (less read calls to the server).
         * his overhead is most noticeable on high latency connections because each
         * ransfered chunk will incur at least RTT of additional transfer time.
         * @returns {module:postgres-large-object/lib/WriteStream}
         */
        this.getWritableStream = function (bufferSize) {
            if (bufferSize === void 0) { bufferSize = 16384; }
            return new WriteStream_1["default"](_this, bufferSize);
        };
        this._sql = sql;
        this.oid = oid;
        this._fd = fd;
    }
    /**
     * A seek from the beginning of a object
     * @constant {number}
     */
    LargeObject.SEEK_SET = SEEK_REF.SEEK_SET;
    /**
     * A seek from the current position
     * @constant {number}
     */
    LargeObject.SEEK_CUR = SEEK_REF.SEEK_CUR;
    /**
     * A seek from the end of a object
     * @constant {number}
     */
    LargeObject.SEEK_END = SEEK_REF.SEEK_END;
    return LargeObject;
}());
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
module.exports = LargeObject;
